{{
*******************************************************************************
* Ported to Propeller by KurtE
*******************************************************************************
Project Lynxmotion Phoenix
Description: Phoenix software
Software version: V2.0
Date: 29-10-2009
Programmer: Jeroen Janssen (aka Xan)

Hardware setup: ABB2 with ATOM 28 Pro, SSC32 V2

NEW IN V2.0
       - Moved to fixed point calculations
       - Inverted BodyRotX and BodyRotZ direction
       - Added deadzone for switching gaits
       - Added GP Player
       - SSC version check to enable/disable GP player
       - Controls changed, Check contol file for more information
       - Added separate files for control and configuration functions
       - Solved bug at turn-off sequence
       - Solved bug about legs beeing lift at small travelvalues in 4 steps tripod gait
       - Solved bug about body translate results in rotate when balance is on (Kre)
       - Sequence for wave gait changed (Kre)
       - Improved ATan2 function for IK (Kre)
       - Added option to turn on/off eyes (leds)
       - Moving legs to init position improved
       - Using Indexed values for legs
       - Added single leg control

KNOWN BUGS:
       - Probably lots!!!

Configuration options:
        Change the CFG object to the appropriate .SPIN file for your Hex
        CHange the Control object to the appropriate control file your desired controller

}}

OBJ 
  DBG : "SerialMirror"  
  SDRIVER : "Phoenix_SSC32"                              ' Use the SSC32 to driver the servos
'  SDRIVER : "Phoenix_PROP_ServoDriver"                  ' use the Prop itself to drive the servos...
  control : "Phoenix_MULTI_Controller"                  ' Choose the controller file you wish to use.                 
'  control : "Phoenix_RC_Controller"                      ' Choose the controller file you wish to use.                 
  CFG   : "Phoenix_Config"                               ' change this to the one specific for your setup.

CON 
    _clkmode = xtal1 + pll16x      '80MHz operating frequency.
    _xinfreq = 5_000_000                      

'--------------------------------------------------------------------

  cTravelDeadZone =  4          'The deadzone for the analog input from the remote

  BUTTON_DOWN =   0
  BUTTON_UP =     1
   
  c1DEC =         10
  c2DEC =         100
  c4DEC =         10000
  c6DEC =         1000000
   
  cRR =           0
  cRM =           1
  cRF =           2
  cLR =           3
  cLM =           4
  cLF =           5
   
  BalanceDivFactor = 6    'Other values than 6 can be used, testing...CAUTION!! At your own risk ;)

DAT    
  GetACos byte      255,254,252,251,250,249,247,246,245,243,242,241,240,238,237,236,234,233,232,231,229,228,227,225 
          byte      224,223,221,220,219,217,216,215,214,212,211,210,208,207,206,204,203,201,200,199,197,196,195,193 
          byte      192,190,189,188,186,185,183,182,181,179,178,176,175,173,172,170,169,167,166,164,163,161,160,158 
          byte      157,155,154,152,150,149,147,146,144,142,141,139,137,135,134,132,130,128,127,125,123,121,119,117 
          byte      115,113,111,109,107,105,103,101,98,96,94,92,89,87,84,81,79,76,73,73,73,72,72,72,71,71,71,70,70 
          byte      70,70,69,69,69,68,68,68,67,67,67,66,66,66,65,65,65,64,64,64,63,63,63,62,62,62,61,61,61,60,60,59
          byte      59,59,58,58,58,57,57,57,56,56,55,55,55,54,54,53,53,53,52,52,51,51,51,50,50,49,49,48,48,47,47,47
          byte      46,46,45,45,44,44,43,43,42,42,41,41,40,40,39,39,38,37,37,36,36,35,34,34,33,33,32,31,31,30,29,28
          byte      28,27,26,25,24,23,23,23,23,22,22,22,22,21,21,21,21,20,20,20,19,19,19,19,18,18,18,17,17,17,17,16
          byte      16,16,15,15,15,14,14,13,13,13,12,12,11,11,10,10,9,9,8,7,6,6,5,3,0 

  GetSin word 0, 87, 174, 261, 348, 436, 523, 610, 697, 784, 871, 958, 1045, 1132, 1218, 1305, 1391, 1478, 1564 
         word        1650, 1736, 1822, 1908, 1993, 2079, 2164, 2249, 2334, 2419, 2503, 2588, 2672, 2756, 2840, 2923, 3007 
         word        3090, 3173, 3255, 3338, 3420, 3502, 3583, 3665, 3746, 3826, 3907, 3987, 4067, 4146, 4226, 4305, 4383 
         word        4461, 4539, 4617, 4694, 4771, 4848, 4924, 4999, 5075, 5150, 5224, 5299, 5372, 5446, 5519, 5591, 5664 
         word        5735, 5807, 5877, 5948, 6018, 6087, 6156, 6225, 6293, 6360, 6427, 6494, 6560, 6626, 6691, 6755, 6819 
         word        6883, 6946, 7009, 7071, 7132, 7193, 7253, 7313, 7372, 7431, 7489, 7547, 7604, 7660, 7716, 7771, 7826 
         word        7880, 7933, 7986, 8038, 8090, 8141, 8191, 8241, 8290, 8338, 8386, 8433, 8480, 8526, 8571, 8616, 8660 
         word        8703, 8746, 8788, 8829, 8870, 8910, 8949, 8987, 9025, 9063, 9099, 9135, 9170, 9205, 9238, 9271, 9304 
         word        9335, 9366, 9396, 9426, 9455, 9483, 9510, 9537, 9563, 9588, 9612, 9636, 9659, 9681, 9702, 9723, 9743 
         word        9762, 9781, 9799, 9816, 9832, 9848, 9862, 9876, 9890, 9902, 9914, 9925, 9935, 9945, 9953, 9961, 9969 
         word        9975, 9981, 9986, 9990, 9993, 9996, 9998, 9999, 10000

'//SSC Pin numbers
        cCoxaPin byte CFG#cRRCoxaPin,  CFG#cRMCoxaPin,  CFG#cRFCoxaPin, CFG#cLRCoxaPin, CFG#cLMCoxaPin, CFG#cLFCoxaPin
        cFemurPin byte  CFG#cRRFemurPin, CFG#cRMFemurPin, CFG#cRFFemurPin, CFG#cLRFemurPin, CFG#cLMFemurPin, CFG#cLFFemurPin
        cTibiaPin byte CFG#cRRTibiaPin, CFG#cRMTibiaPin, CFG#cRFTibiaPin, CFG#cLRTibiaPin, CFG#cLMTibiaPin, CFG#cLFTibiaPin
         
'//Min / imax values
     cCoxaMin1 long CFG#cRRCoxaMin1,  CFG#cRMCoxaMin1,  CFG#cRFCoxaMin1, CFG#cLRCoxaMin1, CFG#cLMCoxaMin1, CFG#cLFCoxaMin1
     cCoxaMax1 long CFG#cRRCoxaMax1,  CFG#cRMCoxaMax1,  CFG#cRFCoxaMax1, CFG#cLRCoxaMax1, CFG#cLMCoxaMax1, CFG#cLFCoxaMax1
     cFemurMin1 long CFG#cRRFemurMin1, CFG#cRMFemurMin1, CFG#cRFFemurMin1, CFG#cLRFemurMin1, CFG#cLMFemurMin1, CFG#cLFFemurMin1
     cFemurMax1 long CFG#cRRFemurMax1, CFG#cRMFemurMax1, CFG#cRFFemurMax1, CFG#cLRFemurMax1, CFG#cLMFemurMax1, CFG#cLFFemurMax1
     cTibiaMin1 long CFG#cRRTibiaMin1, CFG#cRMTibiaMin1, CFG#cRFTibiaMin1, CFG#cLRTibiaMin1, CFG#cLMTibiaMin1, CFG#cLFTibiaMin1
     cTibiaMax1 long CFG#cRRTibiaMax1, CFG#cRMTibiaMax1, CFG#cRFTibiaMax1, CFG#cLRTibiaMax1, CFG#cLMTibiaMax1, CFG#cLFTibiaMax1

'//Body Offsets [distance between the center of the body and the center of the coxa]
     cOffsetX long CFG#cRROffsetX, CFG#cRMOffsetX, CFG#cRFOffsetX, CFG#cLROffsetX, CFG#cLMOffsetX, CFG#cLFOffsetX
     cOffsetZ long CFG#cRROffsetZ, CFG#cRMOffsetZ, CFG#cRFOffsetZ, CFG#cLROffsetZ, CFG#cLMOffsetZ, CFG#cLFOffsetZ

'//Default leg angle

     cCoxaAngle1 long CFG#cRRCoxaAngle1, CFG#cRMCoxaAngle1, CFG#cRFCoxaAngle1, CFG#cLRCoxaAngle1, CFG#cLMCoxaAngle1, CFG#cLFCoxaAngle1

'//Start positions for the leg
     cInitPosX long CFG#cRRInitPosX, CFG#cRMInitPosX, CFG#cRFInitPosX, CFG#cLRInitPosX, CFG#cLMInitPosX, CFG#cLFInitPosX
     cInitPosY long CFG#cRRInitPosY, CFG#cRMInitPosY, CFG#cRFInitPosY, CFG#cLRInitPosY, CFG#cLMInitPosY, CFG#cLFInitPosY
     cInitPosZ long CFG#cRRInitPosZ, CFG#cRMInitPosZ, CFG#cRFInitPosZ, CFG#cLRInitPosZ, CFG#cLMInitPosZ, CFG#cLFInitPosZ




VAR   '' Global Variables and Cog Stack Space
  
'====================================================================
'[ANGLES]
  long     CoxaAngle1[6]    'Actual Angle of the horizontal hip, decimals = 1
  long     FemurAngle1[6]    'Actual Angle of the vertical hip, decimals = 1
  long     TibiaAngle1[6]    'Actual Angle of the knee, decimals = 1
'--------------------------------------------------------------------
'[POSITIONS SINGLE LEG CONTROL]
''  byte    fSLHold              'Single leg control mode

  long    LegPosX[6]    'Actual X Posion of the Leg
  long    LegPosY[6]    'Actual Y Posion of the Leg
  long    LegPosZ[6]    'Actual Z Posion of the Leg
'--------------------------------------------------------------------
'[INPUTS]

'--------------------------------------------------------------------
'[GP PLAYER]
  byte    GPEnable        'Enables the GP player when the SSC version ends with "GP<cr>"  - This is set as part of init code
'--------------------------------------------------------------------
'[OUTPUTS]
  byte    LedA    'Red
  byte    LedB    'Green
  byte     LedC    'Orange
  byte    Eyes    'Eyes output
'--------------------------------------------------------------------
'[VARIABLES]
  byte    Index                    'Index universal used
  byte    LegIndex                'Index used for leg Index Number

'GetSinCos / ArcCos
  long            AngleDeg1        'Input Angle in degrees, decimals = 1
  long            sin4             'Output Sinus of the given Angle, decimals = 4
  long            cos4            'Output Cosinus of the given Angle, decimals = 4
  long            AngleRad4        'Output Angle in radials, decimals = 4

'GetAtan2
  long            AtanX            'Input X
  long            AtanY            'Input Y
  long            Atan4            'ArcTan2 output
  long            XYhyp2            'Output presenting Hypotenuse of X and Y

'Body position
' Now part of control object
   
'Body Inverse Kinematics
  long            wPosX            'Input position of the feet X
  long            wPosZ            'Input position of the feet Z
  long            wPosY            'Input position of the feet Y
  long            BodyIKPosX        'Output Position X of feet with Rotation
  long            BodyIKPosY        'Output Position Y of feet with Rotation
  long            BodyIKPosZ        'Output Position Z of feet with Rotation
  
' New with zentas stuff
  long            BodyRotOffsetY    'Input Y offset value to adjust centerpoint of rotation
  long            BodyRotOffsetZ    'Input Z offset value to adjust centerpoint of rotation


'Leg Inverse Kinematics
  byte            IKSolution        'Output true if the solution is possible
  byte            IKSolutionWarning    'Output true if the solution is NEARLY possible
  byte            IKSolutionError    'Output true if the solution is NOT possible
'--------------------------------------------------------------------
'[TIMING]
  long            lTimerStart    'Start time of the calculation cycles
  long            lTimerEnd        'End time of the calculation cycles
  long            CycleTime        'Total Cycle time

  long            SSCTime        'Time for servo updates
  long            PrevSSCTime        'Previous time for the servo updates

'--------------------------------------------------------------------
'[GLOABAL]
'  byte            g_fHexOn            'Switch to turn on Phoenix
  byte            g_fPrev_HexOn        'Previous loop state 

'--------------------------------------------------------------------
'[Balance]
  long            TotalTransX
  long             TotalTransZ
  long             TotalTransY
  long             TotalYBal1
  long             TotalXBal1
  long             TotalZBal1
   
'[Single Leg Control]
  byte            PrevSelectedLeg
  byte            AllDown
   
'[gait]
  word            NomGaitSpeed        'Nominal speed of the gait
  byte            CurGaitType        ' Loast gait type   
  word            TLDivFactor        'Number of steps that a leg is on the floor while walking
  word            NrLiftedPos        'Number of positions that a single leg is lifted [1-3]
  byte            halfLiftHeight        'If TRUE the outer positions of the ligted legs will be half height    
   
  byte            GaitInMotion         'Temp to check if the gait is in motion
  byte            StepsInGait        'Number of steps in gait
  byte            LastLeg             'TRUE when the current leg is the last leg of the sequence
  byte            GaitStep            'Actual Gait step
   
  byte            GaitLegNr[6]        'Init position of the leg
   
  byte            GaitLegNrIn        'Input Number of the leg
   
  long             GaitPosX[6]        'Array containing Relative X position corresponding to the Gait
  long             GaitPosY[6]        'Array containing Relative Y position corresponding to the Gait
  long             GaitPosZ[6]         'Array containing Relative Z position corresponding to the Gait
  long             GaitRotY[6]        'Array containing Relative Y rotation corresponding to the Gait
   
  byte            fWalking            '  True if the robot are walking
  byte            fContinueWalking    ' should we continue to walk?
  word            wDelayTime
   
   
Pub Start | check
  DBG.start(31,30,0,38400)       ' Initialize comms from Prop to PC

  DBG.str(string("Propeller Phoenix V1.0", 13))
  
  
  appInitSoftware
  repeat
    MainLoop

pub delay(waitms)
  ' Note I need to convert the waitms into milliseconds...
  waitcnt(clkfreq/1000*waitms + cnt)
   
'=============================================================================
' Initialise the software
'=============================================================================
PUB appInitSoftware

'Checks SSC version number if it ends with "GP"
'enable the GP player if it does
    
  DBG.str(string("AppInitSoftware", 13))
  delay(10)

  GPEnable := SDriver.Init     ' The driver retrieves info from config file to know what pins or the like to use

  'Turning off all the leds
  LedA := 0
  LedB := 0
  LedC := 0
  Eyes := 0
         
  'Tars Init Positions
  repeat LegIndex from 0 to 5
    LegPosX[LegIndex] := cInitPosX[LegIndex]    'Set start positions for each leg
    LegPosY[LegIndex] := cInitPosY[LegIndex]
    LegPosZ[LegIndex] := cInitPosZ[LegIndex]  
     
  'Single leg control. Make sure no leg is selected
  PrevSelectedLeg := 255
   
  BodyRotOffsetY := 0        'Input Y offset value to adjust centerpoint of rotation
  BodyRotOffsetZ := 0
   
      
  'Gait
  GaitStep := 1
  GaitSelect
   
  'Initialize Controller
  DBG.str(STRING("Before Init Controller", 13))
  control.Init(GPEnable)
  DBG.str(STRING("After Init Controller", 13))
    
  'SSC
  SSCTime := 150


'============================================================================:=
' This is the main loop
'============================================================================:=
pub MainLoop
   
  'Start time
  lTimerStart := cnt         ' get the system count 
  'Read input
  control.Input
  
  ' BUGBUG::
  if control.GaitType <> CurGaitType
    GaitSelect
   
  ' Some debug stuff...
  'GP Player
  if GPEnable
    GPPlayer
          
  'Single leg control
  SingleLegControl
          
  'Gait
  GaitSeq
           
  'Balance calculations
  TotalTransX := 0     'reset values used for calculation of balance
  TotalTransZ := 0
  TotalTransY := 0
  TotalXBal1 := 0
  TotalYBal1 := 0
  TotalZBal1 := 0
  if control.BalanceMode
    repeat LegIndex from 0 to 2  ' balance calculations for all Right legs
      BalCalcOneLeg (-LegPosX[LegIndex]+GaitPosX[LegIndex],LegPosZ[LegIndex]+GaitPosZ[LegIndex],(LegPosY[LegIndex]-cInitPosY[LegIndex])+GaitPosY[LegIndex], LegIndex)

    repeat LegIndex from 3 to 5  ' balance calculations for all lef legs...
      BalCalcOneLeg(LegPosX[LegIndex]+GaitPosX[LegIndex], LegPosZ[LegIndex]+GaitPosZ[LegIndex],(LegPosY[LegIndex]-cInitPosY[LegIndex])+GaitPosY[LegIndex], LegIndex)

    BalanceBody
          
 'Reset IKsolution indicators 
  IKSolution := 0 
  IKSolutionWarning := 0 
  IKSolutionError := 0 
         
  'Do IK for all Right legs
  repeat LegIndex from 0 to 2  ' balance calculations for all Right legs
    BodyIK(-LegPosX[LegIndex]+control.BodyPosX+GaitPosX[LegIndex] - TotalTransX, LegPosZ[LegIndex]+control.BodyPosZ+GaitPosZ[LegIndex] - TotalTransZ, LegPosY[LegIndex]+control.BodyPosY+GaitPosY[LegIndex] - TotalTransY,                GaitRotY[LegIndex], LegIndex)
                               
    LegIK (LegPosX[LegIndex]-control.BodyPosX+BodyIKPosX-(GaitPosX[LegIndex] - TotalTransX), LegPosY[LegIndex]+control.BodyPosY-BodyIKPosY+GaitPosY[LegIndex] - TotalTransY, LegPosZ[LegIndex]+control.BodyPosZ-BodyIKPosZ+GaitPosZ[LegIndex] - TotalTransZ, LegIndex)
          
  'Do IK for all Left legs  
  repeat LegIndex from 3 to 5 
        BodyIK(LegPosX[LegIndex]-control.BodyPosX+GaitPosX[LegIndex] - TotalTransX, LegPosZ[LegIndex]+control.BodyPosZ+GaitPosZ[LegIndex] - TotalTransZ, LegPosY[LegIndex]+control.BodyPosY+GaitPosY[LegIndex] - TotalTransY, GaitRotY[LegIndex], LegIndex)
        LegIK (LegPosX[LegIndex]+control.BodyPosX-BodyIKPosX+GaitPosX[LegIndex] - TotalTransX, LegPosY[LegIndex]+control.BodyPosY-BodyIKPosY+GaitPosY[LegIndex] - TotalTransY,  LegPosZ[LegIndex]+control.BodyPosZ-BodyIKPosZ+GaitPosZ[LegIndex] - TotalTransZ, LegIndex)
  'Check mechanical limits
  CheckAngles
                
  'Write IK errors to leds
  LedC := IKSolutionWarning
  LedA := IKSolutionError
          
  'Drive Servos
  if control.HexOn
    if ( not g_fPrev_HexOn) 
        'MSound(SOUND_PIN, 3, 60, 2000, 80, 2250, 100, 2500)
        'XBeePlaySounds(3, 60, 2000, 80, 2250, 100, 2500)
        Eyes := 1
       
      'Set SSC time
    if ((||(control.TravelLengthX)>cTravelDeadZone) or (||(control.TravelLengthZ)>cTravelDeadZone) or (||(control.TravelRotationY*2)>cTravelDeadZone))         
          SSCTime := NomGaitSpeed + (control.InputTimeDelay*2) + control.SpeedControl
              
          'Add aditional delay when Balance mode is on
          if (control.BalanceMode)
              SSCTime := SSCTime + 100
    else 'Movement speed excl. Walking
          SSCTime := 200 + control.SpeedControl
      
      ' note we broke up the servo driver into start/commit that way we can output all of the servo information
      ' before we wait and only have the termination information to output after the wait.  That way we hopefully
      ' be more accurate with our timings...
     ' Dump some debug date
'   if control.TravelLengthX or control.TravelLengthZ or control.TravelRotationY 
'     dbg.dec(control.TravelLengthX)
'     dbg.tx(",")
'     dbg.dec(control.TravelLengthZ)
'     dbg.tx(",")
'     dbg.dec(control.TravelRotationY)
'     dbg.tx(":")
'     dbg.dec(control.InputTimeDelay)
'     dbg.tx(":")
'     dbg.dec(control.SpeedControl)
'     dbg.tx(":")
'     dbg.dec(SSCTime)
      
'     dbg.tx(13)

    ServoDriverStart
      
      ' Sync BAP with SSC while walking to ensure the prev is completed before sending the next one
              
    fContinueWalking := false
          
      ' Finding any incident of GaitPos/Rot <>0:
    repeat LegIndex from 0 to 5
        if ( (GaitPosX[LegIndex] > 2) or (GaitPosX[LegIndex] < -2) or (GaitPosY[LegIndex] > 2) or (GaitPosY[LegIndex] < -2) or (GaitPosZ[LegIndex] > 2) or (GaitPosZ[LegIndex] < -2) or (GaitRotY[LegIndex] > 2) or (GaitRotY[LegIndex] < -2) )    
                fContinueWalking := true
                quit

    if (fWalking or fContinueWalking)
        fWalking := fContinueWalking
              
        'Get endtime and calculate wait time
        lTimerEnd := cnt
        'if (lTimerEnd > lTimerStart)
         CycleTime := (lTimerEnd-lTimerStart)/(clkfreq /1000)
        'else
         ' CycleTime := (($ffffffff - lTimerEnd + lTimerStart + 1)*1000)/clkfreq
         
        ' if it is less, use the last cycle time...
        'Wait for previous commands to be completed while walking
        wDelayTime := ((PrevSSCTime - CycleTime) #> 1) <# NomGaitSpeed
'       DBG.str(string("Delay:"))
'       DBG.dec(PrevSSCTime)
'       DBG.tx(",")
'       DBG.dec(CycleTime)
'       DBG.tx(",")
'       DBG.dec(wDelayTime)
'       DBG.tx(13)
        delay (wDelayTime) 
'            digitalWrite(3, LOW)
        
    ServoDriverCommit
'   digitalWrite(2, LOW)            

  else
    'Turn the bot off
    if (g_fPrev_HexOn or (AllDown== 0))
        SSCTime := 600
        ServoDriverStart
        ServoDriverCommit
        'MSound(SOUND_PIN, 3, 100, 2500, 80, 2250, 60, 2000)
        'XBeePlaySounds(3, 100, 2500, 80, 2250, 60, 2000)
        delay(600)
    else
        FreeServos
        Eyes := 0
              
  'Store previous control.HexOn State
  if (control.HexOn)
      g_fPrev_HexOn := 1
  else
      g_fPrev_HexOn := 0
   


'--------------------------------------------------------------------
'[ReadButtons] Reading input buttons from the ABB
'--------------------------------------------------------------------
pub ReadButtons

'--------------------------------------------------------------------
'[WriteOutputs] Updates the state of the leds
'--------------------------------------------------------------------
pub WriteOutputs

'--------------------------------------------------------------------
'[GP PLAYER]
pub GPPlayer | abStat, cbRead
    
    'Start sequence
    if (control.GPStart==1)


      if SDriver.CheckSequence(control.GPSeq)
          control.GPSetState(control#GPSTARTED)
          SDriver.RunSequence(control.GPSeq)
          control.GPSetState(control#GPCOMPLETED)
      else
          control.GPSetState(control#GPERROR)
 
'--------------------------------------------------------------------
'[SINGLE LEG CONTROL]
pub SingleLegControl

  'Check if all legs are down
    AllDown := (LegPosY[cRF]==cInitPosY[cRF]) and (LegPosY[cRM]==cInitPosY[cRM]) and (LegPosY[cRR]==cInitPosY[cRR]) and (LegPosY[cLR]==cInitPosY[cLR]) and (LegPosY[cLM]==cInitPosY[cLM]) and (LegPosY[cLF]:=cInitPosY[cLF])

    if (control.SelectedLeg <> 255)
        if (control.SelectedLeg<>PrevSelectedLeg) 
            if (AllDown)  'Lift leg a bit when it got selected
                LegPosY[control.SelectedLeg] := cInitPosY[control.SelectedLeg]-20
        
                'Store current status
                  PrevSelectedLeg := control.SelectedLeg
            else 'Return prev leg back to the init position
                LegPosX[PrevSelectedLeg] := cInitPosX[PrevSelectedLeg]
                LegPosY[PrevSelectedLeg] := cInitPosY[PrevSelectedLeg]
                LegPosZ[PrevSelectedLeg] := cInitPosZ[PrevSelectedLeg]
        elseif (not control.fSLHold) 
            LegPosY[control.SelectedLeg] := LegPosY[control.SelectedLeg]+control.SLLegY
            LegPosX[control.SelectedLeg] := cInitPosX[control.SelectedLeg]+control.SLLegX
            LegPosZ[control.SelectedLeg] := cInitPosZ[control.SelectedLeg]+control.SLLegZ     
    else 'All legs to init position
        if (not AllDown) 
            repeat LegIndex from 0 to  5
                LegPosX[LegIndex] := cInitPosX[LegIndex]
                LegPosY[LegIndex] := cInitPosY[LegIndex]
                LegPosZ[LegIndex] := cInitPosZ[LegIndex]
        if (PrevSelectedLeg<>255)
            PrevSelectedLeg := 255


'--------------------------------------------------------------------
pub GaitSelect
  'Gait selector
    CurGaitType := control.GaitType
    if (CurGaitType == 0)  'Ripple Gait 6 steps
        GaitLegNr[cLR] := 1
        GaitLegNr[cRF] := 2    
        GaitLegNr[cLM] := 3      
        GaitLegNr[cRR] := 4      
        GaitLegNr[cLF] := 5      
        GaitLegNr[cRM] := 6
                  
        NrLiftedPos := 1
        halfLiftHeight := 0    
        TLDivFactor := 4
        StepsInGait := 6
        NomGaitSpeed := 100

    if (CurGaitType ==1 )  'Ripple Gait 12 steps
        GaitLegNr[cLR] := 1
        GaitLegNr[cRF] := 3
        GaitLegNr[cLM] := 5
        GaitLegNr[cRR] := 7
        GaitLegNr[cLF] := 9
        GaitLegNr[cRM] := 11
        
        NrLiftedPos := 3
        halfLiftHeight := 0
        TLDivFactor := 8      
        StepsInGait := 12    
        NomGaitSpeed := 85
    
    if (CurGaitType == 2)  'Quadripple 9 steps
        GaitLegNr[cLR] := 1
        GaitLegNr[cRF] := 2
        GaitLegNr[cLM] := 4      
        GaitLegNr[cRR] := 5
        GaitLegNr[cLF] := 7
        GaitLegNr[cRM] := 8
            
        NrLiftedPos := 2
        halfLiftHeight := 0    
        TLDivFactor := 6      
        StepsInGait := 9        
        NomGaitSpeed := 100

     if (CurGaitType == 3)  'Tripod 4 steps
        GaitLegNr[cLR] := 3    
        GaitLegNr[cRF] := 1
        GaitLegNr[cLM] := 1
        GaitLegNr[cRR] := 1
        GaitLegNr[cLF] := 3
        GaitLegNr[cRM] := 3
            
        NrLiftedPos := 1    
        halfLiftHeight := 0        
        TLDivFactor := 2      
        StepsInGait := 4        
        NomGaitSpeed := 150
    
  if (CurGaitType == 4)  'Tripod 6 steps
        GaitLegNr[cLR] := 4    
        GaitLegNr[cRF] := 1
        GaitLegNr[cLM] := 1
        GaitLegNr[cRR] := 1
        GaitLegNr[cLF] := 4
        GaitLegNr[cRM] := 4
            
        NrLiftedPos := 2
        halfLiftHeight := 0    
        TLDivFactor := 4      
        StepsInGait := 6        
        NomGaitSpeed := 100
  
    if (CurGaitType == 5)  'Tripod 8 steps
        GaitLegNr[cLR] := 5
        GaitLegNr[cRF] := 1
        GaitLegNr[cLM] := 1
        GaitLegNr[cRR] := 1
        GaitLegNr[cLF] := 5
        GaitLegNr[cRM] := 5
            
        NrLiftedPos := 3
        halfLiftHeight := 1    
        TLDivFactor := 4      
        StepsInGait := 8        
        NomGaitSpeed := 85
  
    if (CurGaitType == 6)  'Wave 12 steps
        GaitLegNr[cLR] := 1
        GaitLegNr[cRF] := 11
        GaitLegNr[cLM] := 3
        
        GaitLegNr[cRR] := 7
        GaitLegNr[cLF] := 5
        GaitLegNr[cRM] := 9
            
        NrLiftedPos := 1
        halfLiftHeight := 0    
        TLDivFactor := 10      
        StepsInGait := 12        
        NomGaitSpeed := 85

    if (CurGaitType == 7)  'Wave 18 steps
        GaitLegNr[cLR] := 4 
        GaitLegNr[cRF] := 1
        GaitLegNr[cLM] := 7
        
        GaitLegNr[cRR] := 13
        GaitLegNr[cLF] := 10
        GaitLegNr[cRM] := 16
            
        NrLiftedPos := 2
        halfLiftHeight := 0    
        TLDivFactor := 16      
        StepsInGait := 18        
        NomGaitSpeed := 85

'--------------------------------------------------------------------
'[GAIT Sequence]
pub  GaitSeq
    'Calculate Gait sequence
    LastLeg := 0
    repeat LegIndex from 0 to 5 ' for all legs
        if (LegIndex == 5) ' last leg
            LastLeg := 1 
    
        Gait(LegIndex)


'--------------------------------------------------------------------
'[GAIT]
pub Gait (GaitCurrentLegNr)

    'Check if the Gait is in motion
    GaitInMotion := ((||control.TravelLengthX>cTravelDeadZone) or (||control.TravelLengthZ>cTravelDeadZone) or (||control.TravelRotationY>cTravelDeadZone))
    
    'Clear values under the cTravelDeadZone
    if (GaitInMotion==0)
        control.ClearTravelData     

    'Leg middle up position
     'Gait in motion                                                          Gait NOT in motion, return to home position
    if ( (GaitInMotion and (NrLiftedPos==1 or NrLiftedPos==3) and GaitStep==GaitLegNr[GaitCurrentLegNr]) or ( not GaitInMotion and GaitStep==GaitLegNr[GaitCurrentLegNr] and ((||(GaitPosX[GaitCurrentLegNr])>2) or (||(GaitPosZ[GaitCurrentLegNr])>2) or (||(GaitRotY[GaitCurrentLegNr])>2)) ))            'Up
        GaitPosX[GaitCurrentLegNr] := 0
        GaitPosY[GaitCurrentLegNr] := -control.LegLiftHeight
        GaitPosZ[GaitCurrentLegNr] := 0
        GaitRotY[GaitCurrentLegNr] := 0
    else
        'Optional Half heigth Rear
        if ( ((NrLiftedPos==2 and GaitStep==GaitLegNr[GaitCurrentLegNr]) or (NrLiftedPos==3 and (GaitStep==(GaitLegNr[GaitCurrentLegNr]-1) or GaitStep == (GaitLegNr[GaitCurrentLegNr]+(StepsInGait-1)) ))) and GaitInMotion)                 
            GaitPosX[GaitCurrentLegNr] := -control.TravelLengthX/2
            GaitPosY[GaitCurrentLegNr] := -control.LegLiftHeight/(halfLiftHeight+1)
            GaitPosZ[GaitCurrentLegNr] := -control.TravelLengthZ/2
            GaitRotY[GaitCurrentLegNr] := -control.TravelRotationY/2

        else
            'Optional half heigth front
            if (  (NrLiftedPos=>2) and ((GaitStep==(GaitLegNr[GaitCurrentLegNr]+1) or (GaitStep==(GaitLegNr[GaitCurrentLegNr]-(StepsInGait-1))) )) and GaitInMotion)        
                GaitPosX[GaitCurrentLegNr] := control.TravelLengthX/2
                GaitPosY[GaitCurrentLegNr] := -control.LegLiftHeight/(halfLiftHeight+1)
                GaitPosZ[GaitCurrentLegNr] := control.TravelLengthZ/2
                GaitRotY[GaitCurrentLegNr] := control.TravelRotationY/2
            else
                'Leg front down position
                if ((GaitStep==(GaitLegNr[GaitCurrentLegNr]+NrLiftedPos)or GaitStep==(GaitLegNr[GaitCurrentLegNr]-(StepsInGait-NrLiftedPos))) and (GaitPosY[GaitCurrentLegNr]<0) ) 
                      GaitPosX[GaitCurrentLegNr] := control.TravelLengthX/2
                      GaitPosZ[GaitCurrentLegNr] := control.TravelLengthZ/2
                      GaitRotY[GaitCurrentLegNr] := control.TravelRotationY/2          
                      GaitPosY[GaitCurrentLegNr] := 0    'Only move leg down at once if terrain adaption is turned off
                'Move body forward      
                else 
                    GaitPosX[GaitCurrentLegNr] -= control.TravelLengthX/TLDivFactor     
                    GaitPosY[GaitCurrentLegNr] := 0  
                    GaitPosZ[GaitCurrentLegNr] -=  control.TravelLengthZ/TLDivFactor
                    GaitRotY[GaitCurrentLegNr] -= control.TravelRotationY/TLDivFactor
    'Advance to the next step
    if (LastLeg)   'The last leg in this step
        GaitStep := GaitStep+1
        if (GaitStep>StepsInGait)
              GaitStep := 1


'--------------------------------------------------------------------
'[BalCalcOneLeg]
pub BalCalcOneLeg (sPosX, sposZ, sPosY, BalLegNr) | CPR_X, CPR_Y, CPR_Z

    'Calculating totals from center of the body to the feet
    CPR_Z := cOffsetZ[BalLegNr]+sPosZ
    CPR_X := cOffsetX[BalLegNr]+sPosX
    CPR_Y := 150 + sPosY        ' using the value 150 to lower the centerpoint of rotation 'control.BodyPosY +

    TotalTransY += sPosY
    TotalTransZ += CPR_Z
    TotalTransX += CPR_X
    
    GetATan2(CPR_X, CPR_Z)
    TotalYBal1 += (Atan4*1800) / 31415
    
    GetATan2 (CPR_X, CPR_Y)
    TotalZBal1 += ((Atan4*1800) / 31415) -900 'Rotate balance circle 90 deg
    
    GetATan2 (CPR_Z, CPR_Y)
    TotalXBal1 += ((Atan4*1800) / 31415) - 900 'Rotate balance circle 90 deg

{#ifdef DEBUG_BODYCALCS
    if ((control.TravelLengthX <> 0) or (control.TravelLengthZ <>0) )
                rprintfInit(&USBSendByte)
        rprintf("BCOL: %d %d %d %u :: %ld %ld %ld :: %ld %ld %ld\n\r", SPosX, PosZ, PosY, BalLegNr,
                TotalTransY, TotalTransZ, TotalTransX, TotalYBal1, TotalZBal1, TotalXBal1)
            
#endif} 

'--------------------------------------------------------------------
'[BalanceBody]
pub BalanceBody
    TotalTransZ := TotalTransZ/BalanceDivFactor 
    TotalTransX := TotalTransX/BalanceDivFactor
    TotalTransY := TotalTransY/BalanceDivFactor

    if (TotalYBal1 > 0)        'Rotate balance circle by +/- 180 deg
        TotalYBal1 -=  1800
    else
        TotalYBal1 += 1800
    
    if (TotalZBal1 < -1800)    'Compensate for extreme balance positions that causes owerflow
        TotalZBal1 += 3600
    
    if (TotalXBal1 < -1800)    'Compensate for extreme balance positions that causes owerflow
        TotalXBal1 += 3600
    
    'Balance rotation
    TotalYBal1 := -TotalYBal1/BalanceDivFactor
    TotalXBal1 := -TotalXBal1/BalanceDivFactor
    TotalZBal1 := TotalZBal1/BalanceDivFactor

{#ifdef DEBUG_BODYCALCS
    if ((control.TravelLengthX <> 0) or (control.TravelLengthZ <>0) )
                rprintfInit(&USBSendByte)
        rprintf("BBody: %ld %ld %ld :: %ld %ld %ld\n\r", TotalTransY, TotalTransZ,TotalTransX, 
            TotalYBal1, TotalZBal1,TotalXBal1)
#endif}


'--------------------------------------------------------------------
'[GETSINCOS] Get the sinus and cosinus from the angle +/- multiple circles
'AngleDeg1     - Input Angle in degrees
'sin4        - Output Sinus of AngleDeg
'cos4          - Output Cosinus of AngleDeg
pub GetSinCos(AD1) | ABSAngleDeg1

    'Get the absolute value of AngleDeg
    if (AD1 < 0)
        ABSAngleDeg1 := AD1 *-1
    else
          ABSAngleDeg1 := AD1
    
    'Shift rotation to a full circle of 360 deg -> AngleDeg ' 360
    if (AD1 < 0)    'Negative values
        AD1 := 3600-(ABSAngleDeg1-(3600*(ABSAngleDeg1/3600)))
    else                'Positive values
        AD1 := ABSAngleDeg1-(3600*(ABSAngleDeg1/3600))
    
    if (AD1=>0 and AD1=<900)     ' 0 to 90 deg
        sin4 := GetSin[AD1/5]             ' 5 is the presision (0.5) of the table
        cos4 := GetSin[(900-(AD1))/5]
        
    elseif (AD1>900 and AD1=<1800)     ' 90 to 180 deg
        sin4 := GetSin[(900-(AD1-900))/5] ' 5 is the presision (0.5) of the table    
        cos4 := -GetSin[(AD1-900)/5]            
    elseif (AD1>1800 and AD1=<2700) ' 180 to 270 deg
        sin4 := -GetSin[(AD1-1800)/5]     ' 5 is the presision (0.5) of the table
        cos4 := -GetSin[(2700-AD1)/5]
 
    elseif(AD1>2700 and AD1=<3600) ' 270 to 360 deg
        sin4 := -GetSin[(3600-AD1)/5] ' 5 is the presision (0.5) of the table    
        cos4 := GetSin[(AD1-2700)/5]            



'--------------------------------------------------------------------
'(GETARCCOS) Get the sinus and cosinus from the angle +/- multiple circles
'cos4        - Input Cosinus
'AngleRad4     - Output Angle in AngleRad4
pub GetArcCos(gcos4) | NegativeValue

    'Check for negative value
    if (gcos4<0)
        gcos4 := -gcos4
        NegativeValue := 1
    else
        NegativeValue := 0
    
    'Limit gcos4 to his maximal value
    gcos4 := gcos4 <# c4DEC
    
    if ((gcos4=>0) and (gcos4<9000))
        AngleRad4 := GetACos[gcos4/79]                 '79:=table resolution (1/127)
        AngleRad4 := (AngleRad4*616)/c1DEC            '616:=acos resolution (pi/2/255) 
    elseif ((gcos4=>9000) and (gcos4<9900))
        AngleRad4 := GetACos[(gcos4-9000)/8+114]         ' 8:=table resolution (0.1/127), 114 start address 2nd bytetable range 
        AngleRad4 := (AngleRad4*616)/c1DEC             '616:=acos resolution (pi/2/255) 
    elseif ((gcos4=>9900) and (gcos4=<10000))
        AngleRad4 := GetACos[(gcos4-9900)/2+227]         '2:=table resolution (0.01/64), 227 start address 3rd bytetable range 
        AngleRad4 := (AngleRad4*616)/c1DEC             '616:=acos resolution (pi/2/255) 
       
    'Add negative sign
    if (NegativeValue)
        AngleRad4 := 31416 - AngleRad4

    return AngleRad4




'--------------------------------------------------------------------
'(GETATAN2) Simplyfied ArcTan2 function based on fixed point ArcCos
'ArcTanX         - Input X
'ArcTanY         - Input Y
'ArcTan4          - Output ARCTAN2(X/Y)
'XYhyp2            - Output presenting Hypotenuse of X and Y
pub GetATan2 (ATX,ATY)
    XYhyp2 := ^^((ATX*ATX*c4DEC) + (ATY*ATY*c4DEC))
    GetArcCos ((ATX*c6DEC) / XYhyp2)
    
    if (ATY < 0)                ' removed overhead... Atan4 := AngleRad4 * (ATY/||(ATY))  
        Atan4 := -AngleRad4
    else
        Atan4 := AngleRad4
{#if 0 'fdef DEBUG_PINCALCS    
    if (control.HexOn)
    {
                rprintfInit(&USBSendByte)
        rprintf(" GAT(%d, %d)", XYhyp2, Atan4) 
    }
#endif}    
    return Atan4
    
'--------------------------------------------------------------------
'(BODY INVERSE KINEMATICS) 
'BodyRotX         - Global Input pitch of the body 
'BodyRotY         - Global Input rotation of the body 
'BodyRotZ         - Global Input roll of the body 
'RotationY         - Input Rotation for the gait 
'SPosX            - Input position of the feet X 
'PosZ            - Input position of the feet Z 
'SinB                  - Sin buffer for BodyRotX
'CosB               - Cos buffer for BodyRotX
'SinG                  - Sin buffer for BodyRotZ
'CosG               - Cos buffer for BodyRotZ
'BodyIKPosX         - Output Position X of feet with Rotation 
'BodyIKPosY         - Output Position Y of feet with Rotation 
'BodyIKPosZ         - Output Position Z of feet with Rotation
pub BodyIK (SPosX, PosZ, PosY, RotationY, BodyIKLeg) | SinA4, CosA4,SinB4, CosB4, SinG4, CosG4, CPR_X, CPR_Y, CPR_Z

    'Calculating totals from center of the body to the feet 
    CPR_X := cOffsetX[BodyIKLeg]+SPosX
    CPR_Y := PosY + BodyRotOffsetY         'Define centerpoint for rotation along the Y-axis
    CPR_Z := cOffsetZ[BodyIKLeg] + PosZ + BodyRotOffsetZ

    'Successive global rotation matrix: 
    'Math shorts for rotation: Alfa [A] := Xrotate, Beta [B] := Zrotate, Gamma [G] := Yrotate 
    'Sinus Alfa := SinA, cosinus Alfa := cosA. and so on... 
    
    'First calculate sinus and cosinus for each rotation: 
    GetSinCos (control.BodyRotX1+TotalXBal1)
    SinG4 := sin4
    CosG4 := cos4
    
    GetSinCos (control.BodyRotZ1+TotalZBal1) 
    SinB4 := sin4
    CosB4 := cos4
    
    GetSinCos (control.BodyRotY1+(RotationY*c1DEC)+TotalYBal1) 
    SinA4 := sin4
    CosA4 := cos4
    
    'Calcualtion of rotation matrix: 
      BodyIKPosX := (CPR_X*c2DEC - (CPR_X*c2DEC*CosA4/c4DEC*CosB4/c4DEC - CPR_Z*c2DEC*CosB4/c4DEC*SinA4/c4DEC + CPR_Y*c2DEC*SinB4/c4DEC ))/c2DEC
      BodyIKPosZ := (CPR_Z*c2DEC - ( CPR_X*c2DEC*CosG4/c4DEC*SinA4/c4DEC + CPR_X*c2DEC*CosA4/c4DEC*SinB4/c4DEC*SinG4/c4DEC + CPR_Z*c2DEC*CosA4/c4DEC*CosG4/c4DEC - CPR_Z*c2DEC*SinA4/c4DEC*SinB4/c4DEC*SinG4/c4DEC - CPR_Y*c2DEC*CosB4/c4DEC*SinG4/c4DEC ))/c2DEC
      BodyIKPosY := (CPR_Y  *c2DEC - ( CPR_X*c2DEC*SinA4/c4DEC*SinG4/c4DEC - CPR_X*c2DEC*CosA4/c4DEC*CosG4/c4DEC*SinB4/c4DEC + CPR_Z*c2DEC*CosA4/c4DEC*SinG4/c4DEC + CPR_Z*c2DEC*CosG4/c4DEC*SinA4/c4DEC*SinB4/c4DEC + CPR_Y*c2DEC*CosB4/c4DEC*CosG4/c4DEC ))/c2DEC

{#ifdef DEBUG_PINCALCS
    if (control.HexOn and control.TravelLengthX )
    {
                rprintfInit(&USBSendByte)
        rprintf("  CPR XYZ: %d %d %d G4: %d %d ",CPR_X, CPR_Y, CPR_Z, SinG4, CosG4)
        rprintf("B4: %d %d A4: %d %d", SinB4, CosB4, SinA4, CosA4)
        rprintf(" BodyIK(%d %d %d) :=", BodyIKPosX, BodyIKPosY, BodyIKPosZ)
    }
#endif}    



'--------------------------------------------------------------------
'[LEG INVERSE KINEMATICS] Calculates the angles of the coxa, femur and tibia for the given position of the feet
'IKFeetPosX            - Input position of the Feet X
'IKFeetPosY            - Input position of the Feet Y
'IKFeetPosZ            - Input Position of the Feet Z
'IKSolution            - Output true if the solution is possible
'IKSolutionWarning     - Output true if the solution is NEARLY possible
'IKSolutionError    - Output true if the solution is NOT possible
'FemurAngle1           - Output Angle of Femur in degrees
'TibiaAngle1           - Output Angle of Tibia in degrees
'CoxaAngle1            - Output Angle of Coxa in degrees
'--------------------------------------------------------------------
pub LegIK (IKFeetPosX, IKFeetPosY, IKFeetPosZ, LegIKLegNr) | IKSW2, IKA14, IKA24, IKFeetPosXZ, Temp1, Temp2, T3
    
    'Calculate IKCoxaAngle and IKFeetPosXZ
    GetATan2 (IKFeetPosX, IKFeetPosZ)
    CoxaAngle1[LegIKLegNr] := ((Atan4*180) / 3141) + cCoxaAngle1[LegIKLegNr]
    
    'Length between the Coxa and tars [foot]
    IKFeetPosXZ := XYhyp2/c2DEC
    
    'Using GetAtan2 for solving IKA1 and IKSW
    'IKA14 - Angle between SW line and the ground in radians
    IKA14 := GetATan2 (IKFeetPosY, IKFeetPosXZ-CFG#cCoxaLength)
    
    'IKSW2 - Length between femur axis and tars
    IKSW2 := XYhyp2
    
    'IKA2 - Angle of the line S>W with respect to the femur in radians
    Temp1 := (((CFG#cFemurLength*CFG#cFemurLength) - (CFG#cTibiaLength*CFG#cTibiaLength))*c4DEC + (IKSW2*IKSW2))
    Temp2 := (2*CFG#cFemurLength)*c2DEC * IKSW2
    T3 := Temp1 / (Temp2/c4DEC)
    IKA24 := GetArcCos (T3 )
{#if 0 'def DEBUG_PINCALCS
    if (control.HexOn and (control.TravelLengthX < - 30))
    {
                rprintfInit(&USBSendByte)
        rprintf("T1: %ld T2: %ld: T3 %ld AR: %d ", Temp1, Temp2, T3, AngleRad4)
    }
#endif}    
    'IKFemurAngle
    FemurAngle1[LegIKLegNr] := -(IKA14 + IKA24) * 180 / 3141 + 900

    'IKTibiaAngle
    Temp1 := (((CFG#cFemurLength*CFG#cFemurLength) + (CFG#cTibiaLength*CFG#cTibiaLength))*c4DEC - (IKSW2*IKSW2))
    Temp2 := (2*CFG#cFemurLength*CFG#cTibiaLength)
    GetArcCos (Temp1 / Temp2)
    TibiaAngle1[LegIKLegNr] := -(900-AngleRad4*180/3141)
{#if 0 'def DEBUG_PINCALCS
    if (control.HexOn and (control.TravelLengthX < - 30))
    {
                rprintfInit(&USBSendByte)
        rprintf("T1: %lu T2: %lu: AR: %d ", Temp1, Temp2, AngleRad4)
    }
#endif}

    'Set the Solution quality    
    if(IKSW2 < (CFG#cFemurLength+CFG#cTibiaLength-30)*c2DEC)
        IKSolution := 1
    else
        if(IKSW2 < (CFG#cFemurLength+CFG#cTibiaLength)*c2DEC) 
            IKSolutionWarning := 1
        else
            IKSolutionError := 1    
{#ifdef DEBUG_PINCALCS
    if (control.HexOn and (control.TravelLengthX))
    {
                rprintfInit(&USBSendByte)
        rprintf("POS(%d, %d, %d) IKA1: %d, IKSW: %d, IKA2 %d :=>", IKFeetPosX, IKFeetPosY, IKFeetPosZ, IKA14, IKSW2,IKA24)
        rprintf(" CA: %d FA: %d, TA: %d SWE: %x%x%x\n\r", 
                CoxaAngle1[LegIKLegNr],FemurAngle1[LegIKLegNr], TibiaAngle1[LegIKLegNr], IKSolution, IKSolutionWarning, IKSolutionError  )
    }
#endif}    


'--------------------------------------------------------------------
'[CHECK ANGLES] Checks the mechanical limits of the servos
'--------------------------------------------------------------------
pub CheckAngles

    repeat LegIndex from 0 to 5
        CoxaAngle1[LegIndex]  := (CoxaAngle1[LegIndex] #> cCoxaMin1[LegIndex]) <# cCoxaMax1[LegIndex]
        FemurAngle1[LegIndex] := (FemurAngle1[LegIndex] #> cFemurMin1[LegIndex]) <# cFemurMax1[LegIndex]
        TibiaAngle1[LegIndex] := (TibiaAngle1[LegIndex] #> cTibiaMin1[LegIndex]) <# cTibiaMax1[LegIndex]


'--------------------------------------------------------------------
'[SERVO DRIVER Start] Updates the positions of the servos - This outputs
'         as much of the command as we can without committing it.  This
'         allows us to once the previous update was completed to quickly 
'        get the next command to start
'--------------------------------------------------------------------
pub ServoDriverStart

    'Update Right Legs
  
    repeat LegIndex from 0 to 2
        SDriver.OutputPin(LegIndex, -CoxaAngle1[LegIndex] +900, -FemurAngle1[LegIndex]+900, -TibiaAngle1[LegIndex]+900)

      'Update Left Legs
    repeat LegIndex from 3 to 5
        SDriver.OutputPin(LegIndex,CoxaAngle1[LegIndex] +900,FemurAngle1[LegIndex]+900, TibiaAngle1[LegIndex]+900)


'--------------------------------------------------------------------
'[SERVO DRIVER commit] We are readdy to commit the changes...
'         as much of the command as we can without committing it.  This
'         allows us to once the previous update was completed to quickly 
'        get the next command to start
'--------------------------------------------------------------------
pub ServoDriverCommit
    control.AllowInterrupts(false)    ' If on xbee on hserial tell hserial to not processess...
'    disable(TIMERAINT)

    SDriver.Commit(SSCTime)
    PrevSSCTime := SSCTime


'--------------------------------------------------------------------
' SmoothControl (From Zenta) -  This function makes the body 
'            rotation and translation much smoother while walking
'--------------------------------------------------------------------
pub SmoothControl (CtrlMoveInp, ctrlMoveOut, ctrlDivider)
    if (fWalking)
        if (CtrlMoveOut < (CtrlMoveInp - 4))
              return CtrlMoveOut + ||((CtrlMoveOut - CtrlMoveInp)/CtrlDivider)
        elseif (CtrlMoveOut > (CtrlMoveInp + 4))
              return CtrlMoveOut - ||((CtrlMoveOut - CtrlMoveInp)/CtrlDivider)
    return CtrlMoveInp

'--------------------------------------------------------------------
'[FREE SERVOS] Frees all the servos
'--------------------------------------------------------------------
pub FreeServos
    SDriver.FreeServos