{{
Project Lynxmotion Phoenix
Description: Phoenix code configuration file.
      All Hardware connections (excl controls) and body dimensions 
      are configurated in this file. Can be used with V2.0 and above
Configuration version: V1.0
Date: Nov 17, 2010
Programmer: Kurt (aka KurtE)

Hardware setup: Propeller - Currently hardware configured for CHR3 type configuration.

NEW IN V1.0
   - First Release

}}

CON 
    _clkmode = xtal1 + pll16x      '80MHz operating frequency.
    _xinfreq = 5_000_000                      

'[Propeller] - These are the IO pins we are using on the propeller.  Maybe not all depending on which IO controllers we are using

' If we are using the SSC32 than use the following defines
     cSSC_RXPIN   =             2
     cSSC_TXPIN   =             3
     cSSC_BAUD    =             115200

' If we are using the XBee-DIY code
     XBEE_RXPIN = 4
     XBEE_TXPIN = 5
' If we are using the PS2 code
     PS2_FIRSTPIN = 8

' RC Pins - currently assuming 6 pins
     RC_PIN0    = 16     
     RC_PIN1    = 17     
     RC_PIN2    = 18     
     RC_PIN3    = 19     
     RC_PIN4    = 20     
     RC_PIN5    = 21     

'[SSC]
' Define the hex robot specifics - normally in seperate file...
'--------------------------------------------------------------------




'[SSC PIN NUMBERS]
    cRRCoxaPin  =     0   'Rear Right leg Hip Horizontal
    cRRFemurPin  =   1   'Rear Right leg Hip Vertical
    cRRTibiaPin  =   2   'Rear Right leg Knee

    cRMCoxaPin  =    4   'Middle Right leg Hip Horizontal
    cRMFemurPin =    5   'Middle Right leg Hip Vertical
    cRMTibiaPin =    6   'Middle Right leg Knee

    cRFCoxaPin  =    8   'Front Right leg Hip Horizontal
    cRFFemurPin =    9   'Front Right leg Hip Vertical
    cRFTibiaPin =    10   'Front Right leg Knee

    cLRCoxaPin  =    16   'Rear Left leg Hip Horizontal
    cLRFemurPin =    17   'Rear Left leg Hip Vertical
    cLRTibiaPin  =   18   'Rear Left leg Knee

    cLMCoxaPin   =   20   'Middle Left leg Hip Horizontal
    cLMFemurPin  =   21   'Middle Left leg Hip Vertical
    cLMTibiaPin  =   22   'Middle Left leg Knee

    cLFCoxaPin   =    24   'Front Left leg Hip Horizontal
    cLFFemurPin  =     25   'Front Left leg Hip Vertical
    cLFTibiaPin  =   26   'Front Left leg Knee

' Use Prop itself to drive servos
{
    cRRCoxaPin  =     0   'Rear Right leg Hip Horizontal
    cRRFemurPin  =   1   'Rear Right leg Hip Vertical
    cRRTibiaPin  =   12   'Rear Right leg Knee

    cRMCoxaPin  =    13   'Middle Right leg Hip Horizontal
    cRMFemurPin =    14   'Middle Right leg Hip Vertical
    cRMTibiaPin =    15   'Middle Right leg Knee

    cRFCoxaPin  =    16   'Front Right leg Hip Horizontal
    cRFFemurPin =    17   'Front Right leg Hip Vertical
    cRFTibiaPin =    18   'Front Right leg Knee

    cLRCoxaPin  =    19   'Rear Left leg Hip Horizontal
    cLRFemurPin =    20   'Rear Left leg Hip Vertical
    cLRTibiaPin  =   21   'Rear Left leg Knee

    cLMCoxaPin   =   22   'Middle Left leg Hip Horizontal
    cLMFemurPin  =   23   'Middle Left leg Hip Vertical
    cLMTibiaPin  =   24   'Middle Left leg Knee

    cLFCoxaPin   =   25   'Front Left leg Hip Horizontal
    cLFFemurPin  =   26   'Front Left leg Hip Vertical
    cLFTibiaPin  =   27   'Front Left leg Knee

}
'--------------------------------------------------------------------
'[MIN/MAX ANGLES]
    cRRCoxaMin1  =   -750      'Mechanical limits of the Right Rear Leg
    cRRCoxaMax1  =   750
    cRRFemurMin1 =   -900
    cRRFemurMax1 =   550
    cRRTibiaMin1 =   -500
    cRRTibiaMax1 =   750

    cRMCoxaMin1  =   -750      'Mechanical limits of the Right Middle Leg
    cRMCoxaMax1  =   750
    cRMFemurMin1 =   -900
    cRMFemurMax1 =   550
    cRMTibiaMin1 =   -500
    cRMTibiaMax1 =   750

    cRFCoxaMin1  =   -750      'Mechanical limits of the Right Front Leg
    cRFCoxaMax1  =   750
    cRFFemurMin1 =   -900
    cRFFemurMax1 =   550
    cRFTibiaMin1 =   -500
    cRFTibiaMax1 =   750

    cLRCoxaMin1  =   -750      'Mechanical limits of the Left Rear Leg
    cLRCoxaMax1  =   750
    cLRFemurMin1 =   -900
    cLRFemurMax1 =   550
    cLRTibiaMin1 =   -500
    cLRTibiaMax1 =   750

    cLMCoxaMin1  =   -750      'Mechanical limits of the Left Middle Leg
    cLMCoxaMax1  =   750
    cLMFemurMin1 =   -900
    cLMFemurMax1 =   550
    cLMTibiaMin1 =   -500
    cLMTibiaMax1 =   750

    cLFCoxaMin1  =   -750      'Mechanical limits of the Left Front Leg
    cLFCoxaMax1  =   750
    cLFFemurMin1 =   -900
    cLFFemurMax1 =   550
    cLFTibiaMin1 =   -500
    cLFTibiaMax1 =   750
'--------------------------------------------------------------------
'[BODY DIMENSIONS]
    cCoxaLength  =   29      '1.14" = 29mm (1.14 * 25.4)
    cFemurLength =  57     '2.25" = 57mm (2.25 * 25.4)
    'cTibiaLength =   141    '5.55" = 141mm (5.55 * 25.4)
    cTibiaLength =   122    '4.8" = 141mm (5.55 * 25.4)

    cRRCoxaAngle1 =  -600   'Default Coxa setup angle, decimals = 1
    cRMCoxaAngle1 =   0      'Default Coxa setup angle, decimals = 1
    cRFCoxaAngle1 =   600      'Default Coxa setup angle, decimals = 1
    cLRCoxaAngle1 =   -600   'Default Coxa setup angle, decimals = 1
    cLMCoxaAngle1 =   0      'Default Coxa setup angle, decimals = 1
    cLFCoxaAngle1 =   600      'Default Coxa setup angle, decimals = 1

    cRROffsetX   =   -69     'Distance X from center of the body to the Right Rear coxa
    cRROffsetZ   =   119     'Distance Z from center of the body to the Right Rear coxa
    cRMOffsetX   =   -138    'Distance X from center of the body to the Right Middle coxa
    cRMOffsetZ   =   0       'Distance Z from center of the body to the Right Middle coxa
    cRFOffsetX   =   -69     'Distance X from center of the body to the Right Front coxa
    cRFOffsetZ   =   -119    'Distance Z from center of the body to the Right Front coxa

    cLROffsetX   =   69      'Distance X from center of the body to the Left Rear coxa
    cLROffsetZ   =   119     'Distance Z from center of the body to the Left Rear coxa
    cLMOffsetX   =   138     'Distance X from center of the body to the Left Middle coxa
    cLMOffsetZ   =   0       'Distance Z from center of the body to the Left Middle coxa
    cLFOffsetX   =   69      'Distance X from center of the body to the Left Front coxa
    cLFOffsetZ   =   -119    'Distance Z from center of the body to the Left Front coxa

'--------------------------------------------------------------------
'[START POSITIONS FEET]
    cHexInitXZ  =   90        ' was 105 
    CHexInitY   =   80
    
    cRRInitPosX =    45                           ' 53      'Start positions of the Right Rear leg
    cRRInitPosY =    80
    cRRInitPosZ =    78

    cRMInitPosX  =   90  'Start positions of the Right Middle leg
    cRMInitPosY  =   80
    cRMInitPosZ  =   0

    cRFInitPosX  =   45                      'Start positions of the Right Front leg
    cRFInitPosY  =   80
    cRFInitPosZ  =   -78

    cLRInitPosX  =   45                      'Start positions of the Left Rear leg
    cLRInitPosY  =   80
    cLRInitPosZ  =   78

    cLMInitPosX  =   90      'Start positions of the Left Middle leg
    cLMInitPosY  =   80
    cLMInitPosZ  =   0

    cLFInitPosX  =   45                      'Start positions of the Left Front leg
    cLFInitPosY  =   80
    cLFInitPosZ  =   -78
pub Init
    ' currently does nothing bug it wants some public function as part of a class...