{{
Project Lynxmotion Phoenix

This controller file is setup to be able to handle multiple controllers.  If one of the
controllers says it has control it will stay with that one, until it releases.

Hardware setup: PS2 and XBee 

Date: Nov 22, 2010

NEW IN V1.0
 - First Release


}}

OBJ
  DBG   : "SerialMirror"
  CXBEE : "Phoenix_XBee_Controller"  ' Choose the controller file you wish to use.                 
  CPS2  : "Phoenix_PS2_Controller"
CON
  GPSTARTED     = 0    ' Used in the GPSetState function...
  GPCOMPLETED   = 1
  GPERROR       = 2


  NEITHER = 0
  XBEE_ACTIVE = 1
  PS2_ACTIVE = 2  
VAR
'=============================================================================
' Global - Local to this file only...
'=============================================================================
  byte WhichOne       ' which controller are we using right now?      

{{ The following functions are the standard methods that is called by the main phoenix code.
All Control classes need to implement these...
}}

pub HexOn
  '' Returns the currrent HexOn State
  if WhichOne == PS2_ACTIVE
    return CPS2.HexOn
  return CXBEE.HexOn 
    
pub BodyPosX
  if WhichOne == PS2_ACTIVE
    return CPS2.BodyPosX
  return CXBEE.BodyPosX 
  
pub BodyPosY
  if WhichOne == PS2_ACTIVE
    return CPS2.BodyPosY
  return CXBEE.BodyPosY 

pub BodyPosZ
  if WhichOne == PS2_ACTIVE
    return CPS2.BodyPosZ
  return CXBEE.BodyPosZ 

pub BodyRotX1
  if WhichOne == PS2_ACTIVE
    return CPS2.BodyRotX1
  return CXBEE.BodyRotX1 
  
pub BodyRotY1
  if WhichOne == PS2_ACTIVE
    return CPS2.BodyRotY1
  return CXBEE.BodyRotY1 
  
pub BodyRotZ1
  if WhichOne == PS2_ACTIVE
    return CPS2.BodyRotZ1
  return CXBEE.BodyRotZ1 
  
pub TravelLengthX
  if WhichOne == PS2_ACTIVE
    return CPS2.TravelLengthX
  return CXBEE.TravelLengthX 
  
pub TravelLengthZ
  if WhichOne == PS2_ACTIVE
    return CPS2.TravelLengthZ
  return CXBEE.TravelLengthZ 
  
pub TravelRotationY
  if WhichOne == PS2_ACTIVE
    return CPS2.TravelRotationY
  return CXBEE.TravelRotationY 

pub BalanceMode
  if WhichOne == PS2_ACTIVE
    return CPS2.BalanceMode
  return CXBEE.BalanceMode 

pub fSLHold
  if WhichOne == PS2_ACTIVE
    return CPS2.fSLHold
  return CXBEE.fSLHold 

pub GaitType
  if WhichOne == PS2_ACTIVE
    return CPS2.GaitType
  return CXBEE.GaitType 

pub LegLiftHeight
  if WhichOne == PS2_ACTIVE
    return CPS2.LegLiftHeight
  return CXBEE.LegLiftHeight 
    
pub GPSeq
  if WhichOne == PS2_ACTIVE
    return CPS2.GPSeq
  return CXBEE.GPSeq 

pub GPStart  
  if WhichOne == PS2_ACTIVE
    return CPS2.GPStart
  return CXBEE.GPStart 

pub GPSetState(state)
  if WhichOne == PS2_ACTIVE
    return CPS2.GPSetState(state)
  return CXBEE.GPSetState(state) 

pub SelectedLeg
  if WhichOne == PS2_ACTIVE
    return CPS2.SelectedLeg
  return CXBEE.SelectedLeg 
  
pub SLLegX
  if WhichOne == PS2_ACTIVE
    return CPS2.SLLegX
  return CXBEE.SLLegX 

pub SLLegZ
  if WhichOne == PS2_ACTIVE
    return CPS2.SLLegZ
  return CXBEE.SLLegZ 

pub SLLegY
  if WhichOne == PS2_ACTIVE
    return CPS2.SLLegY
  return CXBEE.SLLegY 

pub InputTimeDelay
  if WhichOne == PS2_ACTIVE
    return CPS2.InputTimeDelay
  return CXBEE.InputTimeDelay 

pub SpeedControl
  if WhichOne == PS2_ACTIVE
    return CPS2.SpeedControl
  return CXBEE.SpeedControl 

PUB Init(GPEnable)

  DBG.Str(string("Multi controller Init",13))
  CXBEE.Init(GPEnable)
  CPS2.Init(GPEnable)
  WhichOne := NEITHER

  return true 

PUB   AllowInterrupts(fAllow)    ' If on PS2 on hserial tell hserial to not processess...
  if WhichOne == PS2_ACTIVE
    return CPS2.AllowInterrupts(fAllow)
  return CXBEE.AllowInterrupts(fAllow) 

  ' nothing for now

PUB ClearTravelData
  if WhichOne == PS2_ACTIVE
    return CPS2.ClearTravelData
  return CXBEE.ClearTravelData 
 


PUB Input
'' This is where we decide which controller to use.
  if WhichOne <> XBEE_ACTIVE
      result := CPS2.Input
      if CPS2.HexOn
          if WhichOne == NEITHER
              WhichOne := PS2_ACTIVE
              DBG.str(string("PS2 Controller Active",13))
      elseif WhichOne <> NEITHER
          DBG.str(string("Controller up for grabs",13))
          WhichOne := NEITHER
  if WhichOne <> PS2_ACTIVE
      result := CXBEE.Input
      if CXBEE.HexOn
          if WhichOne == NEITHER
              DBG.str(string("XBee Controller Active",13))
              WhichOne := XBEE_ACTIVE
      elseif WhichOne <> NEITHER
          DBG.str(string("Controller up for grabs",13))
          WhichOne := NEITHER

                  