{{
Project Lynxmotion Phoenix
Description: Phoenix, control file.
  The control input subroutine for the phoenix software is placed in this file.
  Can be used with V2.0 and above
Configuration version: V1.0
Hardware setup: DIY XBee

Date: Nov 17, 2010

NEW IN V1.0
 - First Release


IY CONTROLS:
 - Left Stick (WALKMODE) Body Height / Rotate
     (Translate Mode) Body Height / Rotate body Y 
     (Rotate Mode) Body Height / Rotate body Y
     (Single leg Mode) Move Tars Y 

 - Right Stick (WALKMODE) Walk/Strafe
      (Translate Mode) Translate body X/Z
     (Rotate Mode) Rotate body X/Z
     (Single leg Mode) Move Tars X/Z

  - Left Slider Speed
 - Right Slider Leg Lift Height

 - A    Walk Mode
 - B    Translate Mode
 - C    Rotate Mode
 - D    Single Leg Mode
 - E    Balance Mode on/off
 - F    GP Player mode

 - 0    Turn on/off the bot

 - 1-8   (Walk mode) Switch gaits
 - 1-6   (Single leg mode) Switch legs
 - 1-8   (GP Player mode) Start a sequence
}}

OBJ
  DIY   : "DIY_XBee" ' started off with current XBee code and modified to be like my BAP/C code...       
  DBG   : "SerialMirror"
  CFG   : "Phoenix_Config"                                     ' change this to the one specific for your setup.

VAR
'=============================================================================
' Global - Local to this file only...
'=============================================================================

  ' Lets define the variables that we will set as part of the control object
  byte _fHexOn                  ' Is the Robot supposed to be on/Active?   

  byte _GaitType                 ' Wich Gait is active
  byte _BalanceMode              ' Balance mode
  word _InputTimeDelay           ' Desired Input Time delay generated from the inputs...

' Settings for position and rotation of body 
  long _BodyPosX
  long _BodyPosY
  long _BodyPosZ
  long _BodyRotX1
  long _BodyRotY1
  long _BodyRotZ1
' Settings for how far to move or rotate and left the leg.
  long _TravelLengthX
  long _TravelLengthZ
  long _TravelRotationY
  word _LegLiftHeight

' GP Player settings... Will need info as well from main object...
  byte  _GPSeq         ' Which Sequence
  byte  _GPStart       ' should we start
  byte _fGPEnable      ' need to set as part of the init...

' SingleLegMode

  byte  _SelectedLeg     
  byte _fSLHold
  long _SLLegX
  long _SLLegZ
  long _SLLegY
  
' Not sure about these...
  word    _BodyYOffset

' Non exported values...

  byte    bDIYControlMode       ' Our current control mode...  


DAT     
        GN1 byte    "Ripple 6",0
        GN2 byte    "Ripple 12",0
        GN3 BYTE     "Quadripple 9",0
        GN4 BYTE    "Tripod 4",0
        GN5 BYTE     "Tripod 6",0
        GN6 BYTE    "Tripod 8",0
        GN7 BYTE    "Wave 12",0
        GN8 BYTE    "Wave 18",0
       s_asGateNames word @GN1, @GN2, @GN3, @GN4, @GN5, @GN6, @GN7, @GN8 

        SND_BEEP        byte    1, 50, 2000/25
        SND_HEXON       byte    3, 60, 2000/25, 80, 2250/25, 100, 2500/25
        SND_HEXOFF      byte    3, 60, 2500/25, 80, 2250/25, 100, 1000/25
        SND_BALON       byte    2, 100, 2000/25, 50, 4000/25


con
  WALKMODE      =    0
  TRANSLATEMODE =    1
  ROTATEMODE    =    2
  SINGLELEGMODE =    3
  GPPLAYERMODE  =    4

  GPSTARTED     = 0    ' Used in the GPSetState function...
  GPCOMPLETED   = 1
  GPERROR       = 2

  TravelDeadZone = 4  'The deadzone for the analog input from the remote
  cTravelDeadZone =  4          'The deadzone for the analog input from the remote

  SOUND_PIN = 7                            

pub HexOn
  '' Returns the currrent HexOn State
  return _fhexOn
    
pub BodyPosX
  '' Returns the requested X Body position 
  return _BodyPosX
  
pub BodyPosY
  '' Returns the requested Y Body position 
  return _BodyPosY

pub BodyPosZ
  '' Returns the requested Z Body position 
  return _BodyPosZ

pub BodyRotX1
  return _BodyRotX1
  
pub BodyRotY1
  return _BodyRotY1
  
pub BodyRotZ1
  return _BodyRotZ1
  
pub TravelLengthX
  return _TravelLengthX
  
pub TravelLengthZ
  return _TravelLengthZ
  
pub TravelRotationY
  return _TravelRotationY
pub BalanceMode
  return _BalanceMode
pub fSLHold
  return _fSLHold

pub GaitType
  return _GaitType

pub LegLiftHeight
  return _LegLiftHeight
    
pub GPSeq
  return _GPSeq

pub GPStart  
  return _GPStart       ' should we start


pub SelectedLeg
  return _SelectedLeg
  
pub SLLegX
  return  _SLLegX
  
pub SLLegZ
  return _SLLegZ

pub SLLegY
  return _SLLegY

pub InputTimeDelay
  return _InputTimeDelay

pub SpeedControl
  return 0


PUB Init(GPEnable)

  _fGPEnable := GPEnable
  _fHexOn := 0                     ' Assume the Hex is logically off to start off with...
  _GaitType := 0                   ' Start off assuming Gait 0...

  DBG.Str(string("DIY XBee Init",13))
  DIY.start(CFG#XBEE_RXPIN,CFG#XBEE_TXPIN,0,62500)           ' XBee Comms - RX,TX, Mode, Baud


  ' Lets try to initialize the DIY to use
  'InitDIY
   
   
  ' Clear any stuff left in the buffer
  waitcnt(cnt + 20 * clkfreq / 1000)
  DIY.rxflush
   
'  u16 wMy = GetDIYMY()
'      rprintfInit(&USBSendByte)
'  rprintf("DIY My: %x\n\r", wMy)

  'Body Positions
  _BodyPosX := 0
  _BodyPosY := 0
  _BodyPosZ := 0
      
  'Body Rotations
  _BodyRotX1 := 0
  _BodyRotY1 := 0
  _BodyRotZ1 := 0

   
  _BodyYOffset := 0
  _LegLiftHeight := 50
  _BalanceMode := 0
  _SelectedLeg := 255 ' No Leg selected
  bDIYControlMode := WALKMODE
   
  return true 

PUB   AllowInterrupts(fAllow)    ' If on DIY on hserial tell hserial to not processess...

  ' nothing for now

PUB ClearTravelData
    _TravelLengthX:=0
    _TravelLengthZ:=0
    _TravelRotationY:=0
 


PUB Input | iNumButton, wGPSeqPtr, w

 
  ' Then try to receive a packet of information from the DIY.
  ' It will return true if it has a valid packet
  if DIY.ReceivePacket
   

    if DIY.PacketChanged
      if DIY.PacketForced
        DIY.SendNewDataOnlyPacket(1)

        ' OK lets try "0" button for Start. 
    if DIY.Button(0)
      if(_fHexOn) 
                                'Turn off
         _BodyPosX := 0
         _BodyPosY := 0
         _BodyPosZ := 0
         _BodyRotX1 := 0
         _BodyRotY1 := 0
         _BodyRotZ1 := 0
         _TravelLengthX := 0
         _TravelLengthZ := 0
         _TravelRotationY := 0
         _BodyYOffset := 0
         _SelectedLeg := 255
                      
         DBG.str(string("Hex Off",13))
         DIY.PlaySounds(@SND_HEXOFF)
         MSound (@SND_HEXOFF)
         _fHexOn := 0
      else 
        'Turn on
         DBG.str(string("Hex On",13))
          DIY.PlaySounds(@SND_HEXON)
         MSound (@SND_HEXON)
         _fHexOn := 1

    if _fHexOn 
      if DIY.Button($a) ' check A button 
        DIY.PlaySounds(@SND_BEEP)
        bDIYControlMode := WALKMODE
        DIY.OutputString(STRING("Walking"))
     
      if DIY.Button($b) ' B button test
         'MSound (SOUND_PIN, 1, 50, 2000)
          DIY.PlaySounds(@SND_BEEP)
         bDIYControlMode := TRANSLATEMODE
         DIY.OutputString(STRING("Body Translate"))

      if DIY.Button($c) ' C button test
         'MSound (SOUND_PIN, 1, 50, 2000)
         DIY.PlaySounds(@SND_BEEP)
         bDIYControlMode := ROTATEMODE
         DIY.OutputString(STRING("Body Rotate"))

      if DIY.Button($d) ' D button test - Single Leg
         'MSound (SOUND_PIN, 1, 50, 2000)
         if (_SelectedLeg==255) ' none
           _SelectedLeg := 0                            ' could choose later how to get the right leg
         elseif bDIYControlMode==SINGLELEGMODE 'Double press to turn all legs down
           _SelectedLeg := 255  'none

         bDIYControlMode := SINGLELEGMODE        
         DIY.OutputString (STRING("Single Leg"))

      if DIY.Button($e) ' E button test - Balance mode
        if not _BalanceMode 
          _BalanceMode := 1
          'MSound(SOUND_PIN, 2, 100, 2000, 50, 4000)
          'DIYPlaySounds(2, 100, 2000, 50, 4000)
           DIY.OutputString(STRING("Balance On"))
        else
          _BalanceMode := 0
          'MSound(SOUND_PIN, 1, 250, 1500)
          ' DIYPlaySounds(1, 50, 1500)
           DIY.PlaySounds(@SND_BEEP)
           DIY.OutputString(STRING("Balance Off"))

      if DIY.Button($f) ' F button test - GP Player
        if (_fGPEnable)    'F Button GP Player Mode Mode on/off -- SSC supports this mode
          DIY.OutputString(STRING("Run Sequence"))
          DIY.PlaySounds(@SND_BEEP)
          'MSound (SOUND_PIN, 1, 50, 2000)
                     
           _BodyPosX := 0
           _BodyPosZ := 0
           _BodyRotX1 := 0
           _BodyRotY1 := 0
           _BodyRotZ1 := 0
           _TravelLengthX := 0
           _TravelLengthZ := 0
           _TravelRotationY := 0
                     
            _SelectedLeg := 255  'none
            _fSLHold := 0
                   
            bDIYControlMode := GPPLAYERMODE
        else 
           DIY.OutputString(STRING("Seq Disabled"))
           'MSound (SOUND_PIN, 1, 50, 2000)
   
      iNumButton := DIY.IButtonPressed            ' assume no button
      'Switch gait
      ' We will do slightly different here than the RC version as we have a bit per button
      if ((bDIYControlMode==WALKMODE) and iNumButton>0  and (iNumButton =< 8))  '1-8 Button Gait select   
        if ||(_TravelLengthX)<cTravelDeadZone and  ||(_TravelLengthZ)<cTravelDeadZone and ||(_TravelRotationY*2)<cTravelDeadZone
                    'Switch Gait type
          'MSound(SOUND_PIN, 1, 50, 2000)   'Sound P9, [50\4000]
          _GaitType := iNumButton - 1
          DIY.OutputString(@@s_asGateNames[_GaitType])

      'Switch single leg
      if (bDIYControlMode==SINGLELEGMODE) 
        if (iNumButton=>1 and iNumButton=<6) 
          'MSound(SOUND_PIN, 1, 50, 2000)   'Sound P9, [50\4000]
          _SelectedLeg := iNumButton-1
          _fSLHold := 0
   
        elseif (iNumButton == 9)   'Switch Directcontrol
           'MSound(SOUND_PIN, 1, 50, 2000)   'Sound P9, [50\4000]
           _fSLHold ^= 1    'Toggle _fSLHold
 
      elseif (bDIYControlMode==WALKMODE)
        _SelectedLeg := 255 ' none
        _fSLHold := 0

    'Body Height
     _BodyPosY := DIY.GetValue(DIY#LJOYUD) / 2
   
    'Leg lift height - Right slider has value 0-255 translate to 30-93
      _LegLiftHeight := 30 + DIY.GetValue(DIY#RSLIDER)/5
   
     'Walk mode   
      if (bDIYControlMode==WALKMODE) 
        _TravelLengthX := -(DIY.GetValue(DIY#RJOYLR) - 128)
        _TravelLengthZ := -(DIY.GetValue(DIY#RJOYUD) - 128) 
        _TravelRotationY := -(DIY.GetValue(DIY#LJOYLR) - 128)/3
        '_BodyRotX1 := SmoothControl(((bPacket(PKT_RJOYUD)-128)*2), _BodyRotX1, 2)
        '_BodyRotZ1 := SmoothControl((-(bPacket(PKT_RPOT)-128)*2), _BodyRotZ1, 2)

      'Body move 
      elseif (bDIYControlMode==TRANSLATEMODE)  
         _BodyPosX := (DIY.GetValue(DIY#RJOYLR)-128)/2
         _BodyPosZ := (DIY.GetValue(DIY#RJOYUD)-128)/2
         _BodyRotY1 := (DIY.GetValue(DIY#LJOYLR)-128)*2 ' need to integrate newer
   
            'Body rotate 
      elseif (bDIYControlMode==ROTATEMODE)
          _BodyRotX1 := (DIY.GetValue(DIY#RJOYUD)-128)*2  ' dito need to update
          _BodyRotY1 := (DIY.GetValue(DIY#LJOYLR)-128)*2
          _BodyRotZ1 := -(DIY.GetValue(DIY#RJOYLR)-128)*2
   
            'Single Leg Mode
      elseif (bDIYControlMode == SINGLELEGMODE)
          _SLLegX := (DIY.GetValue(DIY#RJOYLR)-128)
          _SLLegZ := -(DIY.GetValue(DIY#RJOYUD)-128)
          _SLLegY := -(DIY.GetValue(DIY#LJOYLR)-128)/5
   
      elseif (bDIYControlMode == GPPLAYERMODE and iNumButton=>1 and iNumButton=<9)  '1-9 Button Play GP Seq

        if (_GPStart == 0)
          _GPSeq := iNumButton-1
          ' See if we can see if this sequence is defined
            DIY.PlaySounds(@SND_BEEP)
             _GPStart := 1
     'Calculate walking time delay
      _InputTimeDelay := 128 -   (( ||(DIY.GetValue(DIY#RJOYLR)-128) #> ||(DIY.GetValue(DIY#RJOYUD)-128)) #>  ||(DIY.GetValue(DIY#LJOYLR)-128)) + (128 -(DIY.GetValue(DIY#LSLIDER)/2))


    'g_diypPrev := g_diyp ' remember the last packet
  else  
        ' Not a valid packet - we should go to a turned off state as to not walk into things!
    if _fHexOn and DIY.PacketForced
      ' Turn off
      '   MSound (SOUND_PIN, 4, 100,2500, 80, 2250, 100, 2500, 60, 20000) ' play it a little different...

      'Turn off
       _BodyPosX := 0
       _BodyPosY := 0
       _BodyPosZ := 0
       _BodyRotX1 := 0
       _BodyRotY1 := 0
       _BodyRotZ1 := 0
       _TravelLengthX := 0
       _TravelLengthZ := 0
       _TravelRotationY := 0
       _BodyYOffset := 0
       _SelectedLeg := 255
       _fHexOn := 0

return

pub GPSetState (state)
    case state
        GPERROR:
          DIY.OutputString(STRING("Seq Not defined"))
          _GPStart := 0         ' clear out the state  
        GPSTARTED:
          DIY.OutputString(STRING("Start Sequence"))
        GPCOMPLETED:
          DIY.OutputString(STRING("Completed"))
          _GPStart := 0         ' clear out the state  

pub MSound(dataptr) | cNotes
    cNotes := byte[dataptr++]
    repeat cNotes
      beep(SOUND_PIN, byte[dataptr], byte[dataptr + 1] * 25)
      dataptr +=2 


PUB beep(pinn, durr, freqq)
    if durr <> 0                                                       
      durr--
      ctrb[30..26] := %00100
      ctrb[8..0] := pinn
      frqb := calcfrq(freqq)
      if durr <> -2
        phsb := 0
      dira[pinn]~~                                            
      if durr <> -2
        repeat durr * 6000/16 ''''until phsa => durr ??? Not sure about timing, but works...
        'repeat (durr*freqq)/100
        waitpeq(0, |< pinn, 0)                                        
        ctrb := 0
        ctrb := frqb := 0
        durr := 0             

pri calcfrq(f)

  repeat 33
    result <<= 1
    if f => clkfreq
      f -= clkfreq
      result++
    f <<= 1        